﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestDotNetApp
{
    public partial class FormMain : Form
    {
        private Mft_DotNet_Lib.ResultRecord[] m_resultRecord;

        public FormMain()
        {
            InitializeComponent();
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Stopwatch sw = System.Diagnostics.Stopwatch.StartNew();

            int result;

            uint drive = 2; // C Drive

            #if X64
                ulong count = 0;
            #else
                uint count = 0;
            #endif

            // 読み込み
            if ((result = Mft_DotNet_Lib.MftClass.LoadMft(drive, ref count)) != 0)
            {
                MessageBox.Show(Mft_DotNet_Lib.MftClass.GetMftMessage(result));

                return;
            }

            m_resultRecord = new Mft_DotNet_Lib.ResultRecord[count];

            // 取得
            if ((result = Mft_DotNet_Lib.MftClass.GetMft(m_resultRecord)) != 0)
            {
                MessageBox.Show(Mft_DotNet_Lib.MftClass.GetMftMessage(result));

                return;
            }

            sw.Stop();

            Text = (sw.ElapsedMilliseconds / 1000.0).ToString() + " sec";

            Application.DoEvents();

            for (int i = 0; i < m_resultRecord.Length; i++)
            {
                grdView.Rows.Add(m_resultRecord[i].parentId
                                        , m_resultRecord[i].parentName
                                        , m_resultRecord[i].id
                                        , m_resultRecord[i].name
                                        , m_resultRecord[i].actualSize
                                        , m_resultRecord[i].modificationTime
                                        , m_resultRecord[i].flag);
            }
        }
    }
}
